////////////////////////////////////////////////////////////////////
// Cӂ̊֐`wKĂ݂悤I
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>
#include "FFNNs.h"

////////////////////////////////////////////////////////////////////
// ֐`̒`
////////////////////////////////////////////////////////////////////
double f(double x) {
	return  4.0 * (x - 0.5) * (x - 0.5);
}
double x_min = 0.0;
double x_max = 1.0;
////////////////////////////////////////////////////////////////////
// FFNNNXiP̃j[lbg[NjŎgpϐ
////////////////////////////////////////////////////////////////////
std::string post_filename = "_xx";

//wKȂ̏ꍇ͎̃RgAEgO
//#define NO_LEARNING

//ϑľvZ
int meanN = 1000;

//w
const int layerN = 3;

//j[lbg[N̍\
int structure[layerN] = {
	1, //͑w̃j[
	10, //ԑw̃j[
	1  //o͑w̃j[
};
//d݂ƃoCAXq
double weightFactor = 1.0;
double biasFactor = 1.0;

//wK@̎
int typeOfLearning = 0; // 0:Œ, 1:[^@, 2:AdaGrad, 3:RMSprop

//wKp[^
double eta = 0.01;
double mu = 0.5; //1,2,3
double rho = 0.7;//3
double lambda = 0;

//~job`̃TCY
int batch_size = 100;

//wK񐔂̍XV
int delta_iterations = 1000;
//vZlbg[N
const int NNs = 10;

//////////////////////////////////////////////////
// FFNNNX@[U[`p֐
//////////////////////////////////////////////////
//tM^֐iÓI֐ƂĒ`j
void FFNN::calculateTeacherSignal(double* input, double* output) {}
void FFNN::calculateTeacherSignal_inverse(double* output, double* input) {}
//wKpinputf[^@w肷֐
void FFNN::defineInput() {
	double x =  x_min + ( x_max - x_min ) * rand_real_0_1(mt);
	input[0] = x;
	teacherSignalOutput[0] = f(x);
}
//ݒ肵͂ɑ΂鑹l̕ςvZ֐
double FFNN::getMeanLossValue() {

	double sumLoss = 0;
	for (int i = 0; i < meanN; i++) {

		defineInput();

		//j[lbg[N̏vZiPj
		calculateFeedForward();

		sumLoss += lossFunction();

	}
	sumLoss /= double(meanN);

	return sumLoss;

}


int main(void) {
	// t@Co̓Xg[̏
	std::ofstream ofs, ofs_L, ofs_weight;
	std::ifstream if_weight;

	//vZێp
	std::ostringstream information;
	information << "#############################" << std::endl;
	information << "## ֐̊wKiwKj" << std::endl;
	information << "#############################" << std::endl;
	information << "##jbgF";
	for (int i = 0; i < layerN; i++) {
		information << structure[i];
		if (i != layerN-1) information << "-";
	}
	information << std::endl;
	information << "##wK@F" << typeOfLearning << std::endl;
	information << "##ob`F" << batch_size << std::endl;
	information << "##etaF" << eta << std::endl;
	information << "##muF" << mu << std::endl;
	information << "##rhoF" << rho << std::endl;
	information << "##lambdaF" << rho << std::endl;
	information << "##weightFactorF" << weightFactor << std::endl;
	information << "##biasFactorF" << biasFactor << std::endl;

	//t@Cwp
	std::ostringstream _filename;
	_filename << "FFNN_F_type" << typeOfLearning << "_";
	for (int i = 0; i < layerN; i++) {
		_filename << structure[i];
		if (i != layerN-1) _filename << "-";
	}
	_filename << post_filename;
	//tH_̐
	_mkdir("output");
	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/" << _filename.str() << ".txt";
	//o̓Xg[ɂt@CI[v
	ofs.open(filename.str());
	ofs << information.str();
	
#ifndef NO_LEARNING
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_epoch.txt";
	//o̓Xg[ɂt@CI[v
	ofs_L.open(filename.str());
	ofs_L << information.str();
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_weight.txt";
	//o̓Xg[ɂt@CI[v
	ofs_weight.open(filename.str());
	ofs_weight << information.str();

#else
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "input/FFNN_PM_type0_2-100-1_sin_weight.txt";
	//o̓Xg[ɂt@CI[v
	if_weight.open(filename.str());
#endif

	//vJn
	clock_t start = clock();

	FFNNs ffnns(NNs, layerN, structure);
	ffnns.eta = eta;
	ffnns.batch_size = batch_size;
	ffnns.adoptFactor(weightFactor, biasFactor);
	ffnns.typeOfLearning = typeOfLearning;
	ffnns.mu = mu;
	ffnns.rho = rho;
	ffnns.lambda = lambda;

	#ifndef NO_LEARNING
	ofs_L << "####################" << std::endl;
	ofs_L << "#x:G|bN" << std::endl;
	ofs_L << "#y:l" << std::endl;
	ofs_L << "#showLines: false false false false false" << std::endl;
	ofs_L << "#showMarkers: true true true true true" << std::endl;
	ofs_L << "#set logscale y" << std::endl;
	ofs_L << "#xrange:0 " << delta_iterations*100 << " " << delta_iterations * 10 << std::endl;
	for (int epochN = 0; epochN <= 100; epochN++) {

		if (epochN == 0) ffnns.iterations = 0;
		else ffnns.iterations = delta_iterations;

		ffnns.learnNetworks();
		ffnns.updateLowerToHigher();

		double top1 = ffnns.lossVales[ffnns.ranking[0]];
		double top2 = ffnns.lossVales[ffnns.ranking[1]];
		double top3 = ffnns.lossVales[ffnns.ranking[2]];
		double top4 = ffnns.lossVales[ffnns.ranking[3]];
		double top5 = ffnns.lossVales[ffnns.ranking[4]];

		ofs_L << delta_iterations * epochN << " " << top1 << " " << top2 << " " << top3 << " " << top4 << " " << top5 << std::endl;
		std::cout << "t = "<< delta_iterations * epochN << std::endl;
	}
	
	//vI
	ofs_L.close();

	#else
	//wKς݃lbg[N̓ǂݍ
	ffnns.readDumpNetwork( if_weight );
	ffnns.loadNetwork();
	if_weight.close();
	#endif
	ofs << "####################" << std::endl;
	ofs << "#x:x" << std::endl;
	ofs << "#y:f(x)" << std::endl;
	ofs << "#showLines: true false true false true false" << std::endl;
	ofs << "#showMarkers: false true false true false true" << std::endl;
	ofs << "#xrange:0 1 0.1" << std::endl;

	double *teacherSignalOutput = new double[structure[layerN-1]];
	double *output1 = new double[structure[layerN-1]];
	double *input1 = new double[structure[0]];

	double sum = 0;

	for (int nx = 0; nx <= 100; nx++) {
		double x = x_min + ( x_max - x_min ) * double(nx) / 100.0;
		input1[0] = x;
		ffnns.calculateByBestNeuralNetwork(input1, output1);
		ofs << x << " " << f(x) << " " << output1[0] <<  std::endl;

		sum += pow(f(x) - output1[0], 2) / 2.0 /100.0;
	}
	ofs.close();

	clock_t end = clock();
	std::cout << "vZԁF" << end - start  << "  Loss=" << sum << std::endl;
	std::cout << "finish" << std::endl;

	#ifndef NO_LEARNING
	ffnns.dumpNetwork( ofs_weight );
	ofs_weight.close();
	#endif

	int b;
	std::cin >> b;
	return b;
}

/*
gccRpC
g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2 -fopenmp
g++ -c FFNNs.cpp -std=c++14 -O2 -fopenmp
g++ -c main.cpp -std=c++14 -O2 -fopenmp
g++ main.o Matrix.o FFNN.o FFNNs.o -fopenmp


g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2
g++ -c FFNNs.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Matrix.o FFNN.o FFNNs.o
*/